#!--------------------------------------------------------------------------------------!
#! File:        AyoMSSQL.tpl
#! Copyright:
#! Author:      Ayodele Ogundahunsi
#! Email:       ayodele@dolasoft.com
#!--------------------------------------------------------------------------------------!
#! This template works only with Microsoft SQL Server
#!
#!--------------------------------------------------------------------------------------!
#! AyoMSSQLGlobal       Global Extension (Extension)
#! InitSQL              SQL Initialisation (Procedure)
#! SProcWizard        Create Stored Procedures entry point (Procedure)
#!--------------------------------------------------------------------------------------!
#!--------------------------------------------------------------------------------------!
#TEMPLATE (AyoMSSQL, 'SQL Integration Templates (ClarionMag)'),FAMILY('ABC')
#!--------------------------------------------------------------------------------------!
#!HELP ('AyoSQL.HLP')
#SYSTEM
#DECLARE (%SQLString)
#DECLARE (%TransformTempFilesList),MULTI
#!
#!
#!---------------------------------------------------------------------------------------------------------------------------------------------------
#PROCEDURE (ExecuteSQL,'Common function for Embedded SQL (NAMEd Theory)')
#! Create a procedure for sending embedded SQL to Server (Using the NAMEd Table Theory)
#!---------------------------------------------------------------------------------------------------------------------------------------------------
#DECLARE (%ViewOrFile)
#IF     (%ResultSetMethod = 'Smart NAMEd Table')
    #SET (%ViewOrFile,'FILE')
#ELSIF  (%ResultSetMethod = 'Stupid Table')
    #SET (%ViewOrFile,'VIEW')
#ENDIF
%[20]Procedure %ProcedureType(ResultFile,SQLString)
#PROTOTYPE('( FILE, *CSTRING), BYTE, PROC')
#INSERT (%ExecutePropSQL,%SQLString)
#!---------------------------------------------------------------------------------------------------------------------------------------------------
#!
#!---------------------------------------------------------------------------------------------------------------------------------------------------
#PROCEDURE (ExecuteSQL_ST,'Common function for Embedded SQL (Stupid Theory)')
#! Create a procedure for sending embedded SQL to Server (Using the Stupid Table Theory)
#!---------------------------------------------------------------------------------------------------------------------------------------------------
%[20]Procedure %ProcedureType(ResultFile,SQLString)
#PROTOTYPE('( VIEW, *CSTRING), BYTE, PROC')
#INSERT (%ExecutePropSQL,%SQLString)
#!---------------------------------------------------------------------------------------------------------------------------------------------------
#!
#!
#!INCLUDE('AyoSQL_DATE.TPW')
   #!INCLUDE('AyoSQL_SPROC.TPW')
   #!INCLUDE('AyoSQL_GROUPS.TPW')
   #!INCLUDE('AyoSQL_MSSQL.TPW')
#!
#! Update History:
#!
#!
#!
#!--------------------------------------------------------------------
#GROUP (%ExecutePropSQL,%LogResultString)
!--------------------------------------------------------------------
! This procedure allows you to send a string of SQL commands to the server
!--------------------------------------------------------------------
    #DISPLAY('AyoSQL Templates By Ayo Ogundahunsi')
  CODE
    SETCURSOR(Cursor:Wait)                  !-- Change cursor to hourglass --
    #EMBED (%SendingSQLRequest,'SQL Extension')
    ResultFile{prop:SQL}=SQLString          !-- Send SQL string to Server --
    SETCURSOR()                             !-- Reset cursor to normal --

    !---- Connection Error ----
    IF ERRORCODE() = 90 THEN
      STOP(CLIP(FILEERROR()) & ' (' & CLIP(FILEERRORCODE()) & ')')
    ELSIF ERRORCODE()<>0 THEN
      STOP(CLIP(ERROR()) & ' (' & ERRORCODE() & ')')
    END
    !--------------------------
!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#!
#!
#!
#!---------------------------------------------------------------------------------------------------------------------------------------------------
#EXTENSION (AyoMSSQLGlobal,'MSSQL Global Template Declaration[Required]'),APPLICATION
#!---------------------------------------------------------------------------------------------------------------------------------------------------
#PREPARE
    #!INSERT (%AYODeclareSymbols)
    #DECLARE (%FileCounter,LONG)
    #IF (NOT VAREXISTS(%SPListLocation))
        #DECLARE(%SPListLocation)
    #ENDIF
#ENDPREPARE
#DISPLAY('')
#DISPLAY('SQL Templates')
#DISPLAY('')
#SHEET,HSCROLL,ADJUST   
    #TAB ('Properties')
        #BOXED ('Connection Variables ')
            #PROMPT ('SQL Server Name:',FROM(%GlobalData)),%SQLServerNameVar,DEFAULT('MSSQL:Server') 
            #PROMPT ('Database Name:',FROM(%GlobalData)),%DataBaseNameVar,DEFAULT('MSSQL:Database')
            #PROMPT ('User name:',FROM(%GlobalData)),%UserNameVar,DEFAULT('MSSQL:UserName') 
            #PROMPT ('Password:',FROM(%GlobalData)),%UserPasswordVar,DEFAULT('MSSQL:Password') 
            #PROMPT ('Connection String:',FROM(%GlobalData)),%ConnectionVariable,DEFAULT('MSSQL:ConnectionString') 
        #ENDBOXED
        #BOXED ('Connection Values (Default)')
            #PROMPT ('SQL Server Name:',@S40),%SQLServerName,DEFAULT('(local)') 
            #PROMPT ('Database Name:',@S50),%DataBaseName,REQ
            #ENABLE (%UseTrustedConnection=%false)
                #PROMPT ('User name:',@S20),%UserName,DEFAULT('sa') 
                #PROMPT ('Password:',@S15),%UserPassword,DEFAULT('sa') 
            #ENDENABLE
            #PROMPT ('Use Trusted Connection:',CHECK ),%UseTrustedConnection,DEFAULT(0), AT(10,,100,15)
        #ENDBOXED
        #PROMPT ('Default Script Location',@S60),%DefaultScriptDIR
        #PROMPT ('Default Embedded SQL Proc.', FROM(%Procedure,sub(%ProcedureTemplate,1,10)='ExecuteSQL') ),%DefaultEmbeddedSQLProc
    #ENDTAB
    #TAB ('Database')
        #PROMPT ('Open All Tables after connecting?',OPTION),%OpenAllTables
        #PROMPT ('Yes',RADIO)
        #PROMPT ('No',RADIO)
        #ENABLE (%OpenAllTables='No')
            #BUTTON ('Select Tables to open after connecting'),AT(,,174,15)
                #DISPLAY (' ')
                #BOXED ('Tables to open')
                    #PROMPT ('File Selection',FROM(%File,%FileDriver='MSSQL')),%FilesToOpen,INLINE,SELECTION('File Selection')
                #ENDBOXED
            #ENDBUTTON
        #ENDENABLE
        #DISPLAY ('')
        #BOXED ('Define SQL Result Table')
            #PROMPT ('How will Results be returned',OPTION),%ResultSetMethod
            #PROMPT ('Smart NAMEd Table',RADIO)
            #PROMPT ('Stupid Table',RADIO)
            #DISPLAY ('')
            #PROMPT ('Number of Columns returned:',SPIN(@n2,1,99)),%NumberOfColumns,DEFAULT(10)
            #PROMPT ('Width of Columns:',SPIN(@n3,11,5001)),%WidthOfColumns,DEFAULT(21)
            #ENABLE (%ResultSetMethod = 'Smart NAMEd Table')            
                #PROMPT ('NAMEd Table:',@S40),%NamedTable
                #PROMPT ('NAMEd Column:',@S40),%NamedColumn
            #ENDENABLE
        #ENDBOXED
        #DISPLAY ('')
    #ENDTAB 
#ENDSHEET

#!------------ Variables --------------
#GLOBALDATA
MSSQL:Server            CSTRING(41)
MSSQL:Database          CSTRING(51)
MSSQL:UserName          CSTRING(21)
MSSQL:Password          CSTRING(16)
MSSQL:Server:Temp       CSTRING(41)
MSSQL:Database:Temp     CSTRING(51)
MSSQL:UserName:Temp     CSTRING(21)
MSSQL:Password:Temp     CSTRING(16)
MSSQL:ConnectionString  CSTRING(129)
MSSQL:SaveLogin         BYTE
#ENDGLOBALDATA


#AT (%GlobalData),PRIORITY(1000)
ASCII_CHAR:SINGLE_QUOTE     EQUATE ('<039>')
ASCII_CHAR:COMMA            EQUATE ('<044>')

    #CALL (%GenerateFileDefinition)     #! Generates file definition for the SQL Result table
    #IF (NOT VAREXISTS(%SQLScriptFile))
        #DECLARE (%SQLScriptFile)
    #ENDIF
    #SET (%ColCounter,1)
    #IF ( SUB (%DefaultScriptDIR,LEN(%DefaultScriptDIR),1) <> '\') 
        #SET (%SQLScriptFile,%DefaultScriptDIR &'\'& 'sqlresult.sql')   
    #ELSE
        #SET (%SQLScriptFile,%DefaultScriptDIR & 'sqlresult.sql')   
    #ENDIF
    #INSERT (%GenerateSQLScript)            #! Generates SQL Script for the SQL Result table

#ENDAT
#!---------------------------------------------------------------------------------------------------------------------------------------------------
#!
#!
#!
#!---------------------------------------------------------------------------------------------------------------------------------------------------
#! SQL Initialisation. Can be added to Application Frame or Source                                !
#!---------------------------------------------------------------------------------------------------------------------------------------------------
#EXTENSION (InitMSSQL,'SQL Initialisation in Application Frame[Required]'),PROCEDURE,REQ(AyoMSSQLGlobal)
#!---------------------------------------------------------------------------------------------------------------------------------------------------
#LOCALDATA
ScratchString            CSTRING(129)
#ENDLOCALDATA
#DISPLAY ('Initialize Application to run SQL Server')
#AT (%WindowManagerMethodCodeSection, 'Init', '(),BYTE'),WHERE(%ProcedureTemplate = 'Frame' OR %ProcedureTemplate = 'Menu' OR %ProcedureTemplate = 'Window' OR %ProcedureTemplate = 'Browse'),PRIORITY(8001)
    #CALL (%ConnectAndOpenFiles)
#ENDAT
#AT (%ProcessedCode, 'Processed Code', '(),BYTE'),WHERE(%ProcedureTemplate = 'Source'),PRIORITY(8001)
    #CALL (%ConnectAndOpenFiles)
#ENDAT
#!---------------------------------------------------------------------------------------------------------------------------------------------------
#!
#!
#!
#!
#!
#!--------------------------------------------------------------------
#! Generates file definition for the SQL Result table
#!--------------------------------------------------------------------
#GROUP(%GenerateFileDefinition)
!--------------------------------------------------------------------
! Generates file definition for the SQL Result table
!--------------------------------------------------------------------
    #DECLARE (%ColCounter,LONG)
    #SET (%ColCounter,1)
    #IF     (%ResultSetMethod = 'Smart NAMEd Table')
SQLRESULT           FILE,DRIVER('MSSQL'),OWNER(%ConnectionVariable),NAME('dbo.%NamedTable'),PRE(SQLRESULT),BINDABLE,THREAD
    #ELSIF (%ResultSetMethod = 'Stupid Table')
SQLRESULT           FILE,DRIVER('MSSQL'),OWNER(%ConnectionVariable),NAME('dbo.SQLRESULT'),PRE(SQLRESULT),BINDABLE,THREAD
PK_SQLRESULT            KEY(SQLRESULT:ID_SQLRESULT),NOCASE,PRIMARY
    #ENDIF
Record                  RECORD,PRE()
    #LOOP, WHILE (%ColCounter <= %NumberOfColumns)
        #IF     (%ResultSetMethod = 'Smart NAMEd Table')
Column%[10]ColCounter           CSTRING(%WidthOfColumns),NAME('%NamedColumn')
        #ELSIF (%ResultSetMethod = 'Stupid Table')
Column%[10]ColCounter           CSTRING(%WidthOfColumns)
        #ENDIF
        #SET (%ColCounter,%ColCounter+1)
    #ENDLOOP
    #IF (%ResultSetMethod = 'Stupid Table')
ID_SQLRESULT                LONG
    #ENDIF
                        END
                    END         
Access:SQLRESULT    &FileManager    !Create an instance
!--------------------------------------------------------------------
#!
#!
#!
#!--------------------------------------------------------------------
#! Generates connection code and opens file(s)
#!--------------------------------------------------------------------
#GROUP(%ConnectAndOpenFiles)
#DECLARE (%DisplayVarPos)
#DECLARE (%CurrentTitleText)
!--------------------------------------------------------------------
! Try to establish a connection with the server
!--------------------------------------------------------------------
    #SET (%DisplayVarPos,'0{{PROP:Text}')
    ScratchString = 0{PROP:Text}

#EMBED (%BeforeReusingLoginfo,'Before Reusing Login Information')
#!--- Read settings from INI File, or Registry, or Control File ---
    !--- Read connection details from specified source ---
    INIMgr.Fetch('SQL Server','servername',MSSQL:Server:Temp)
    INIMgr.Fetch('SQL Server','database',MSSQL:Database:Temp)
    INIMgr.Fetch('SQL Server','userid',MSSQL:UserName:Temp)
    INIMgr.Fetch('SQL Server','password',MSSQL:Password:Temp)

    IF MSSQL:Server:Temp = ''
        #!%SQLServerNameVar = '(local)'
        %SQLServerNameVar = '%SQLServerNameVar'
    ELSE
        %SQLServerNameVar = MSSQL:Server:Temp
    END

    IF MSSQL:Database:Temp = ''
        %DataBaseNameVar = '%DataBaseName'
    ELSE
        %DataBaseNameVar = MSSQL:Database:Temp
    END
    
    IF MSSQL:UserName:Temp = ''
        %UserNameVar = 'sa'
    ELSE
        %UserNameVar = MSSQL:UserName:Temp
    END
    
    IF MSSQL:Password:Temp = ''
        %UserPasswordVar = 'sa'
    ELSE
        %UserPasswordVar = MSSQL:Password:Temp
    END
#!-----------------------------------------------------------------
#EMBED (%BeforeFillingConnection,'Before Filling Connection String')
    %DataBaseNameVar='%DataBaseName'
#IF (%SQLServerNameVar='')
    #!SET(%DisplayLogon,'Yes')
#ENDIF
    MSSQL:ConnectionString = %SQLServerNameVar&','&%DataBaseNameVar&','&%UserNameVar&','&%UserPasswordVar
    !MESSAGE(MSSQL:ConnectionString)
#EMBED (%AfterFillingConnection,'After Filling Connection String')
    %DisplayVarPos = 'Checking Connection with database.....';  DISPLAY(?)
    SQLRESULT{PROP:LogonScreen}=True
#EMBED (%BeforeOpeningConnection,'Before Opening a Connection')
#IF (%UseTrustedConnection=%true)
    SEND (SQLRESULT, '/TRUSTEDCONNECTION = TRUE')
#ENDIF

    xNo# = 1    
    LOOP xNo# TIMES
        OPEN(SQLRESULT)                 !Attempting to open a file will create a conection. Note: Must match dbo.SQLRESULT
#EMBED (%AfterOpeningConnection,'After Opening a Connection')
        !MESSAGE(SQLRESULT{PROP:ConnectString})
        IF ERRORCODE()
            CASE MESSAGE('Unable to connect. Retry?','Connection Error ...',ICON:Exclamation,BUTTON:RETRY+BUTTON:CANCEL,BUTTON:CANCEL,1)
            OF BUTTON:RETRY
                xNo# = 1    
                CYCLE
            OF BUTTON:CANCEL
                HALT (1)
            END
        END
    END
    !------ Save connection details to INI File ------
    INIMgr.Update('SQL Server','servername',%SQLServerNameVar)
    INIMgr.Update('SQL Server','database',%DataBaseNameVar)
    INIMgr.Update('SQL Server','userid',%UserNameVar)
    INIMgr.Update('SQL Server','password',%UserPasswordVar)
    !-------------------------------------------------
!--------------------------------------------------------------------

!--------------------------------------------------------------------
! Open Table(s) and display name in Status bar 
!--------------------------------------------------------------------
#IF (%OpenAllTables='Yes')
    #FOR (%File),WHERE(%FileDriver='MSSQL')
        %DisplayVarPos = 'Attempting to Open %File .......';DISPLAY(?) 
        ACCESS:%File.OPEN; %DisplayVarPos = '%File Opened ..' ;DISPLAY(?)

    #ENDFOR
#ELSIF (%OpenAllTables='No')
    #FOR (%FilesToOpen)
    #!,WHERE(%FileDriver='MSSQL')
        %DisplayVarPos = 'Attempting to Open %FilesToOpen .......';DISPLAY(?) 
        ACCESS:%FilesToOpen.OPEN ; %DisplayVarPos = '%FilesToOpen Opened ..';DISPLAY(?) 

    #ENDFOR
    %DisplayVarPos = 'Connected ..';DISPLAY(?) 
#ENDIF
!--------------------------------------------------------------------
    %DisplayVarPos = ScratchString ;DISPLAY(?) 
#!--------------------------------------------------------------------
#!
#!
#!
#!--------------------------------------------------------------------
#! Generates SQL Script for the SQL Result table
#!--------------------------------------------------------------------
#GROUP(%GenerateSQLScript)
#PREPARE
#ENDPREPARE
	#REMOVE (%SQLScriptFile)
	#CREATE (%SQLScriptFile)

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[SQLRESULT]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[SQLRESULT]
GO

CREATE TABLE [dbo].[SQLRESULT] (
	#LOOP,WHILE(%ColCounter <= %NumberOfColumns)
	[Column%ColCounter] [varchar] (%WidthOfColumns) NULL ,
    	#SET (%ColCounter,%ColCounter+1)
	#ENDLOOP
	[ID_SQLRESULT] [int] IDENTITY (1, 1) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[SQLRESULT] WITH NOCHECK ADD 
	CONSTRAINT [PK_RESULT] PRIMARY KEY  CLUSTERED 
	(
		[ID_SQLRESULT]
	)  ON [PRIMARY] 
GO
	#CLOSE (%SQLScriptFile)
#!--------------------------------------------------------------------
#!
#!
#!
#!---------------------------------------------------------------------------------------------------------------------------------------------------
#!  AyoSQL - Stored Procedure/SQL Entry Point Template
#!  ----------------------------------------------
#!  Version 1.00      08/20/2002
#!  (c) Copyright DolaSoft Technologies, 2000-02    All Rights reserved Worldwide.
#!--------------------------------------------------------------------------------------------------------------------------------------------------
#PROCEDURE (LinkStoredProcOrSQL,'Stored Procedure or SQL Entry Point')
#!--------------------------------------------------------------------------------------------------------------------------------------------------
#LOCALDATA
Action                       BYTE      !Disk action variable
#ENDLOCALDATA
#PROMPT ('Parameters', @s255), %Parameters          #! Retrieve parameters used
#IF (%Parameters)                                  	#! IF Parameters used
%[20]Procedure %ProcedureType %Parameters         	#<! Declare Procedure
#ELSE                                             	#! ELSE (IF parameters not used)
%[20]Procedure %ProcedureType                     	#<! Declare Procedure
#ENDIF                                            	#! END (IF parameters used)
#ENABLE (%ProcedureType='FUNCTION')
  #PROMPT ('Return Value:',FIELD),%ReturnValue
#ENDENABLE
#DISPLAY (' ')
#SHEET,HSCROLL, ADJUST 
	#!TAB ('Access to SQL Backend')
		#PROMPT ('Entry point is provided by:',OPTION),%EntryPointType
		#PROMPT ('Stored Procedure',RADIO)
		#PROMPT ('Stored Procedure Name:', @S100),%StoredProcedureName,DEFAULT(%Procedure),REQ
		#DISPLAY ('')
		#PROMPT ('Return Value(s) - Target Data Structure',OPTION),%WhatReturnValue      
		#PROMPT ('Single Value',RADIO)
		#PROMPT ('GROUP Structure',RADIO)
		#PROMPT ('QUEUE Structure',RADIO)
        #PROMPT ('Approx. No. of Columns returned:',SPIN(@n2,1,100)),%ColumnsReturned,DEFAULT(10)
		#DISPLAY (' ')
		#BOXED ('Embedded SQL Caller')
			#PROMPT ('Procedure:', FROM(%Procedure,sub(%ProcedureTemplate,1,10)='ExecuteSQL') ),%EmbeddedSQLProc,DEFAULT(%DefaultEmbeddedSQLProc)
		#ENDBOXED
	#!ENDTAB
#ENDSHEET
#!
#!
#INSERT (%AYODeclareSymbols)
#SET(%UseableCharacters,'ABCEDFGHIJKLMNOPQRSTUVWXYZ1234567890')
#SET(%LeftBracket,'''( ''&')
#SET(%RightBracket,'&'' )''')
#SET(%Join2Param,'&'',''&')
#SET(%JoinAsComma,'&'',''')
#SET(%PComma,''',''')
#SET(%Ampersand,' & ')
#SET(%LeftStringParam,'&<039>')
#SET(%RightStringParam,'<039>&')
#SET(%HardQuoteL,'<<039>''&')
#SET(%HardQuoteR,'&''<<039>''')
#SET(%HardQuote,'''<<039>''')
#SET(%HardQuoteRBracket,'&''<<039>)')
#SET(%HardQuoteLBracket,'(<<039>''&')
#SET(%NoQuoteLBracket,'(''&')
#SET(%NoQuoteRBracket,'&'')')
#SET(%SoftQuoteR,'&''')
#SET(%QuoteCommaQuote,'<<039>,<<039>')
#SET(%AddedParam,0)
#SET(%ProjectNo,1)
#SET(%UseReturnCode,0)
#IF (%Parameters)                              #! IF Parameters used
	#SET (%ParameterNoBracket, SUB(%Parameters,2,LEN(%Parameters)-2))
!%%pROTOTYPE = %pROTOTYPE
	#SET (%Qn, INSTRING (',',%Parameters,1,1 ) )
	#IF (%Qn = 0 )
		#IF ( INSTRING('STRING',UPPER(%ProtoType),1,1) OR INSTRING('CSTRING',UPPER(%ProtoType),1,1))
			#SET (%StringToPass,'CALL '&%StoredProcedureName & %HardQuoteLBracket & CLIP(%ParameterNoBracket) & %HardQuoteRBracket )
		   	#!SET (%StringToPass,%StringToPass & %Seperator & %Ampersand & %HardQuote & %Ampersand & %ParamToUse & %Ampersand  & %HardQuote )
		#ELSE
			#SET (%StringToPass,'CALL '&%StoredProcedureName & %NoQuoteLBracket & %ParameterNoBracket & %NoQuoteRBracket )
			#!%%StringToPass (Qn=0,not STRING/CSTRING) = %StringToPass
		#ENDIF
	#ELSE
		#SET (%PrototypeString, %Parameters)
	#!INSERT (%GetLastPrototype,%PrototypeString, %LastPrototype)	!Available in full template set
		#SET (%LastParameter,%LastPrototype)
		#!
		#SET (%PrototypeString, %Prototype)
	#!INSERT (%GetLastPrototype,%PrototypeString, %LastPrototype)	!Available in full template set
		#IF 	(%WhatReturnValue='QUEUE Structure')
				#SET (%PrototypeString,SUB(%PrototypeString,1,INSTRING(%LastPrototype,%PrototypeString,1,1)-1)&'QUEUE)')
		#ELSIF	(%WhatReturnValue='GROUP Structure')
				#SET (%PrototypeString,SUB(%PrototypeString,1,INSTRING(%LastPrototype,%PrototypeString,1,1)-1)&'GROUP)')
		#ENDIF
		#!--------------------------------------------------------------
		#! This INSERTed #GROUP splits the prototype and parameter list
		#! and then constructs the SQ string to be passed to the server
	#!INSERT (%SplitParameterList,%Parameters,%PrototypeString)		!Available in full template set
		#!--------------------------------------------------------------
	#ENDIF
#ELSE	
	#SET (%StringToPass,'CALL '&%StoredProcedureName&'()' )
#ENDIF
#!
#!
#!IF 	(%ResultSetMethod = 'Smart NAMEd Table')
#!----------------------------------------------------
#IF (%ResultSetMethod = 'Stupid Table')
SQLResultView  %[0]NULL 	  VIEW(SQLResult)
	#LOOP, UNTIL( %ProjectNo = %ColumnsReturned )
%[26]NULL PROJECT(SQLResult:Column%ProjectNo)
		#SET (%ProjectNo,%ProjectNo+1)
	#ENDLOOP
%[21]NULL END
#ENDIF
#!----------------------------------------------------
StringToPass   %[0]NULL       CSTRING(512)
Qf 		       %[0]NULL       ANY
  CODE
#IF 	(%ResultSetMethod = 'Smart NAMEd Table')
	#EMBED (%BeforeOpenSQLRESULT,'Before NAMEd SQLRESULT is opened')
%[0]NULL    OPEN(SQLRESULT)
	#EMBED (%AfterOpenSQLRESULT,'After NAMEd SQLRESULT is opened')
#ELSIF 	(%ResultSetMethod = 'Stupid Table')
	#EMBED (%BeforeOpenView,'Before Dummy View is opened')
%[0]NULL    OPEN(SQLResultView)
	#EMBED (%AfterOpenView,'After Dummy View is opened')
#ENDIF
#IF		(%EntryPointType='Stored Procedure')
%[0]NULL    StringToPass = '%StringToPass'	
#ELSIF 	(%EntryPointType='SQL Code')
%[0]NULL    StringToPass = 	'%SQLString'	
#ENDIF
#!This is the composed SQL String : %SQLString
#EMBED (%ComposeString,'After composing string to be passed to Backend - "StringToPass"')
#IF 	(%ResultSetMethod = 'Smart NAMEd Table')
%[0]NULL    IF %EmbeddedSQLProc (SQLRESULT,StringToPass) = Level:Benign
%[0]NULL    LOOP
%[0]NULL    NEXT(SQLRESULT)
    	#!embed error handiling here
#ELSIF 	(%ResultSetMethod = 'Stupid Table')
%[0]NULL    IF %EmbeddedSQLProc (SQLResultView,StringToPass) = Level:Benign
%[0]NULL       LOOP
%[0]NULL          NEXT(SQLResultView)
#ENDIF
#EMBED (%AfterRetrievingFromView,'After Record(s) are retrievd from Backend')
%[0]NULL          IF ERRORCODE() THEN BREAK.
#IF (%WhatReturnValue='QUEUE Structure' OR %WhatReturnValue='QUEUE Structure')
%[0]NULL          CLEAR(%LastParameter)
	#SET (%ProjectNo,1)
	#LOOP, UNTIL(%ProjectNo = %ColumnsReturned)
%[0]NULL          Qf &= WHAT(%LastParameter,%ProjectNo) ;	Qf =  SQLResult:Column%ProjectNo
		#SET (%ProjectNo,%ProjectNo+1)
		#IF 	(%StructureUsed=%GROUPStructure)
%[0]NULL          PUT (%LastParameter)
%[0]NULL          BREAK	!Force process out of LOOP after 1st record has filled GROUP
		#ELSIF	(%StructureUsed=%QUEUEStructure)
		#ENDIF
	#ENDLOOP
%[0]NULL          ADD(%LastParameter)
#ELSE
	#! ASSIGN TO RETURN VALUE HERE
#ENDIF
%[0]NULL       END
%[0]NULL    END
#EMBED (%AfterFillingReturnValues,'After filling Return Value(s) with retrieved value')
#!
#IF (%ResultSetMethod = 'Stupid Table')
%[0]NULL    CLOSE(SQLResultView)	
#ENDIF
    !Access:SQLResult.Close
#IF (%ProcedureReturnType)
	!RETURN(%ReturnValue)
#ENDIF
#!---------------------------------------------------------------------------------------------------------------------------------------------------

#!-------------------------------------------------------------------------------------------------------------
#!This GROUP contains symbol declarations
#!-------------------------------------------------------------------------------------------------------------
#GROUP(%AYODeclareSymbols)
	#DECLARE (%AYOStoredProcName),MULTI,UNIQUE							#!Filled with name(s) of stored procedure(s)
	#DECLARE (%AYOStoredProcOParam,%AYOStoredProcName)		#!Filled with Output parameter(s)
	#DECLARE (%AYOStoredProcIParam,%AYOStoredProcName),MULTI,UNIQUE		#!Filled with Input parameter(s)
	#DECLARE (%AYOStoredProcIDataType)
	#DECLARE (%AYOConnectionString)								#!
	#DECLARE (%AYOTextOutputFile)
	#DECLARE (%AYONextLine)
	#DECLARE (%AYOExtractedSPName)
	#DECLARE (%AYOExtractedIPName)
	#DECLARE (%AYOExtractedOPName)
		#DECLARE (%ParameterNames),MULTI
    #IF (NOT VAREXISTS(%QUEUEStructure))
		#DECLARE(%QUEUEStructure, STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%GROUPStructure))
		#DECLARE(%GROUPStructure, STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%SingleStructure))
		#DECLARE(%SingleStructure, STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%UseableCharacters))
		#DECLARE(%UseableCharacters, STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%RightBracketPos))
		#DECLARE(%RightBracketPos,LONG)
	#ENDIF
    #IF (NOT VAREXISTS(%CommaPos))
		#DECLARE(%CommaPos,LONG)
	#ENDIF
    #IF (NOT VAREXISTS(%PrototypeString))
		#DECLARE(%PrototypeString,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%ParameterString))
		#DECLARE(%ParameterString,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%Counter))
		#DECLARE(%Counter,LONG)
	#ENDIF
    #IF (NOT VAREXISTS(%RightBracket))
		#DECLARE(%RightBracket,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%LeftBracket))
		#DECLARE(%LeftBracket,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%HardQuoteL))
		#DECLARE(%HardQuoteL,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%HardQuoteR))
		#DECLARE(%HardQuoteR,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%HardQuote))
		#DECLARE(%HardQuote,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%SoftQuoteR))
		#DECLARE(%SoftQuoteR,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%QuoteCommaQuote))
		#DECLARE(%QuoteCommaQuote,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%Join2Param))
		#DECLARE(%Join2Param,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%JoinAsComma))
		#DECLARE(%JoinAsComma,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%PComma))
		#DECLARE(%PComma,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%Ampersand))
		#DECLARE(%Ampersand,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%LeftStringParam))
		#DECLARE(%LeftStringParam,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%RightStringParam))
		#DECLARE(%RightStringParam,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%StringToPass))
		#DECLARE(%StringToPass,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%AddedParam))
		#DECLARE(%AddedParam,LONG)
	#ENDIF
    #IF (NOT VAREXISTS(%ThisIsAGroup))
		#DECLARE(%ThisIsAGroup,LONG)
	#ENDIF
    #IF (NOT VAREXISTS(%ProjectNo))
		#DECLARE(%ProjectNo,LONG)
	#ENDIF
    #IF (NOT VAREXISTS(%FieldsToGroup))
		#DECLARE(%FieldsToGroup),MULTI,UNIQUE
	#ENDIF
    #IF (NOT VAREXISTS(%ReturnFieldsToGroup))
		#DECLARE(%ReturnFieldsToGroup,STRING)
	#ENDIF
    #IF (NOT VAREXISTS(%UseReturnCode))
		#DECLARE(%UseReturnCode,LONG)
	#ENDIF
    #IF (NOT VAREXISTS(%StructureUsed))
		#DECLARE(%StructureUsed)
	#ENDIF
    #IF (NOT VAREXISTS(%PrototypeNew))
		#DECLARE (%PrototypeNew)
	#ENDIF
    #IF (NOT VAREXISTS(%Qn))
		#DECLARE (%Qn,LONG)
	#ENDIF
    #IF (NOT VAREXISTS(%Gn))
		#DECLARE (%Gn,LONG)
	#ENDIF
    #IF (NOT VAREXISTS(%LastPrototype))
		#DECLARE (%LastPrototype)
	#ENDIF
    #IF (NOT VAREXISTS(%LastParameter))
		#DECLARE (%LastParameter)
	#ENDIF
    #IF (NOT VAREXISTS(%HardQuoteRBracket))
		#DECLARE (%HardQuoteRBracket)
	#ENDIF
    #IF (NOT VAREXISTS(%HardQuoteLBracket))
		#DECLARE (%HardQuoteLBracket)
	#ENDIF
	#IF (NOT VAREXISTS(%ParameterNoBracket))
		#DECLARE (%ParameterNoBracket)
	#ENDIF
	#IF (NOT VAREXISTS(%NoQuoteRBracket))
		#DECLARE (%NoQuoteRBracket)
	#ENDIF
	#IF (NOT VAREXISTS(%NoQuoteLBracket))
		#DECLARE (%NoQuoteLBracket)
	#ENDIF
