SET QUOTED_IDENTIFIER ON
CREATE TABLE dbo."products"(
   "ProductNumber" VARCHAR(13) NOT NULL,
   "ProductSKU" VARCHAR(10),
   "Description" VARCHAR(35) NOT NULL,
   "Price" DECIMAL(7,2),
   "QuantityInStock" DECIMAL(7,2),
   "ReOrderQuantity" DECIMAL(7,2),
   "Cost" DECIMAL(7,2),
   "PictureFile" VARCHAR(64),
   CONSTRAINT "KeyProductNumber" PRIMARY KEY ("ProductNumber"),
   CONSTRAINT "KeyProductSku" UNIQUE ("ProductSKU"))
CREATE INDEX "KeyDescription" ON dbo."products"("Description")

CREATE TABLE dbo."vendors"(
   "VendorNumber" VARCHAR(13) NOT NULL,
   "VendorName" VARCHAR(35),
   "Address1" VARCHAR(35),
   "Address2" VARCHAR(35),
   "City" VARCHAR(25),
   "State" VARCHAR(2),
   "ZipCode" VARCHAR(10),
   "PhoneNumber" VARCHAR(10),
   CONSTRAINT "KeyVendorNumber" PRIMARY KEY ("VendorNumber"))
CREATE INDEX "KeyVendorName" ON dbo."vendors"("VendorName")

CREATE TABLE dbo."invhist"(
   "RecordID" VARCHAR(13),
   "Date" DATETIME NOT NULL DEFAULT (getdate()),
   "Type" VARCHAR(7) NOT NULL,
   "ProductNumber" VARCHAR(13),
   "Quantity" DECIMAL(7,2) NOT NULL,
   "VendorNumber" VARCHAR(13),
   "Cost" DECIMAL(7,2),
   "Notes" VARCHAR(50),
   CONSTRAINT "KeyRecordID" PRIMARY KEY ("RecordID"))
CREATE INDEX "KeyProductNumberVendorDate" ON dbo."invhist"("ProductNumber","VendorNumber","Date")
CREATE INDEX "KeyProdNumberDate" ON dbo."invhist"("ProductNumber","Date")
CREATE INDEX "KeyVendorNumberDate" ON dbo."invhist"("VendorNumber","Date")

CREATE TABLE dbo."zipcodes"(
   "ZIP" VARCHAR(10),
   "CITY" VARCHAR(25),
   "STATE" VARCHAR(2),
   CONSTRAINT "KeyZCS" PRIMARY KEY ("ZIP","CITY","STATE"))
CREATE INDEX "KEYZIPCODE" ON dbo."zipcodes"("ZIP")
CREATE INDEX "KEYZIPCITY" ON dbo."zipcodes"("CITY")

